
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

/*
 * asn_octs.h
 *
 * MS 92
 * Copyright (C) 1992 Michael Sample and the University of British Columbia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * $Header: /mnt/users/irorigin/sdl/src/asn/headers/RCS/asn_octs.h,v 1.1 1993/03/17 20:43:25 irorigin Allocated irorigin $
 * $Log: asn_octs.h,v $
 * Revision 1.1  1993/03/17  20:43:25  irorigin
 * Initial revision
 *
 */


#ifndef _asn_octs_h_
#define _asn_octs_h_

typedef struct AsnOcts
{
    unsigned long int octetLen;
    char* octs;
} AsnOcts;

#define ASNOCTS_PRESENT(aocts) ((aocts)->octs != NULL)



AsnLen BEncAsnOcts PROTO((BUF_TYPE b, AsnOcts* data));

void BDecAsnOcts PROTO((BUF_TYPE b, AsnOcts* result, AsnLen* bytesDecoded,
                       ENV_TYPE env));

AsnLen BEncAsnOctsContent PROTO((BUF_TYPE b, AsnOcts* octs));

void BDecAsnOctsContent PROTO((BUF_TYPE b,
                               AsnLen len,
                               AsnTag tagId,
                               AsnOcts* result,
                               AsnLen* bytesDecoded,
                               ENV_TYPE env));

void FreeAsnOcts PROTO((AsnOcts* o));

void PrintAsnOcts PROTO((FILE* f, AsnOcts *o, unsigned short int indent));

int AsnOctsEquiv PROTO((AsnOcts* o1, AsnOcts* o2));


#endif /* conditional include */
