
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/

/*
 * asn_oid.h
 *
 *  this file depends on asn_octs.h
 * MS 92
 * Copyright (C) 1992 Michael Sample and the University of British Columbia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * $Header: /mnt/users/irorigin/sdl/src/asn/headers/RCS/asn_oid.h,v 1.1 1993/03/17 20:43:40 irorigin Allocated irorigin $
 * $Log: asn_oid.h,v $
 * Revision 1.1  1993/03/17  20:43:40  irorigin
 * Initial revision
 *
 */


#ifndef _asn_oid_h_
#define _asn_oid_h_

#include "asn_octs.h"

typedef AsnOcts AsnOid;  /* standard oid type  */


#define ASNOID_PRESENT(aoid) ASNOCTS_PRESENT(aoid)

AsnLen BEncAsnOid PROTO((BUF_TYPE b, AsnOid* data));

void BDecAsnOid PROTO((BUF_TYPE b, AsnOid* result, AsnLen* bytesDecoded,
                       ENV_TYPE env));

#define BEncAsnOidContent(b, oid)   BEncAsnOctsContent(b, oid)


void BDecAsnOidContent PROTO((BUF_TYPE b,
                            AsnTag tag,
                            AsnLen len,
                            AsnOid*  result,
                            AsnLen* bytesDecoded,
                            ENV_TYPE env));


#define FreeAsnOid FreeAsnOcts

void PrintAsnOid PROTO((FILE* f, AsnOid* b, unsigned short int indent));

#define AsnOidsEquiv(o1, o2) AsnOctsEquiv(o1, o2)

/* linked oid type that may be easier to use in some circumstances */
#define NULL_OID_ARCNUM -1
typedef struct OID
{
    struct OID* next;
    long int arcNum;
} OID;

AsnLen EncodedOidLen PROTO((OID* oid));

void BuildEncodedOid PROTO( (OID* oid, AsnOid* result));

void UnbuildEncodedOid PROTO( (AsnOid* eoid, OID** result));

#endif /* conditional include */
