
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 ************************************************************************/

/****************************************************************************
 * HEADER ir_net.h
 *
 * PURPOSE:
 *	This header file is global to the Communication Service CSC only.
 *
 * SCOPE:
 *	
 * NOTES:
 *
 * 
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ****************************************************************************/

#ifndef IR_NET_H

#define IR_NET_H

#include <ir.h>

#ifdef BSDSOCKET
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/select.h>
#include <sys/errno.h>
#include <netdb.h>
#endif

#ifdef WINSOCKET
#include <windows.h>
#include <winsock.h>
#endif

#ifdef WINPATHWAY
#ifdef XVT_MSDOS
#include <windows.h>
#include <xvt.h>
#define _TIME_T_DEFINED
#define NO_TWG_ERRNO
#endif
#include <sys/time.h>
#include <sys/types.h>
#include <sys/errno.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#endif


#ifdef BSDSOCKET

#ifndef SOCKADDR_IN	
#define SOCKADDR_IN	struct sockaddr_in
#endif

#ifndef HOSTENT
#define HOSTENT		struct hostent
#endif

#ifndef SOCKET_ERROR
#define SOCKET_ERROR	(-1)
#endif

#endif	/* BSDSOCKET */

#define dim(x) (sizeof(x) / sizeof(x[0]))

#ifdef XVT_MSDOS 

#define WS10C                    /* define if winsock rev >= 1.0C */

#ifdef WS10C
   #define INET_ADDR inet_addr      
#else                               
   #define INET_ADDR ul_inet_addr
   u_long ul_inet_addr(char *szIP);

   u_long ul_inet_addr(char *szIP)
   {
      IN_ADDR in;

      in = inet_addr(szIP);
      return in.s_addr;
   }
#endif

typedef unsigned long IPA;

#endif

IR_STATUS	UaCs_Init(void);
void		UaCs_Terminate(void);
void 		UaCs_DeleteAssocId(IR_ASSOC_ID assocId);
IR_ASSOC_ID	UaCs_GetNewAssocId(void);

#endif
