
/************************************************************************
 *
 * SR/Z3950 application software version 1.0, August 1993.
 *
 * (C) Software Kinetics Ltd.
 *
 * Software Kinetics Ltd. has granted a licence of this software to the
 * National Library of Canada.
 *
 * The National Library of Canada grants to the user a royalty-free
 * non-exclusive licence in perpetuity to use, modify, improve, reproduce
 * and sell the software.
 *
 * The software is provided to the user "as is" without warranty of any
 * kind. Neither Software Kinetics Ltd. nor the National Library of Canada
 * warrants, guarantees or makes any representations regarding the use,
 * or the results of use of the software in terms of accuracy, reliability,
 * or otherwise. The entire risk as to results and performance of the
 * software is assumed by the user. Neither Software Kinetics Ltd. nor the
 * National Library of Canada shall be liable for any direct, indirect,
 * consequential or incidental damages arising out of the use of the
 * software.
 *
 * $Log:
 * Revision 1.1  1993/09/16  09:03:27  irorigin
 * Baseline for Release 1.0.
 *
 ************************************************************************/


#ifndef _RPNQUERY_H_
#define _RPNQUERY_H_


/* RPN_AttribType */
typedef enum {
	RPN_AT_USE = 1,
	RPN_AT_RELATION,
	RPN_AT_POSITION,
	RPN_AT_STRUCTURE,
	RPN_AT_TRUNCATION,
	RPN_AT_COMPLETENESS
} RPN_AttribType;

void RPN_Attribs_List(int (*add_item)(const char *item_name, RPN_AttribType type, int value, long user_data), long user_data);


/* RPN_AttribComplete */
typedef enum {
    RPN_AT_CPL_UNSPECIFIED	   	   = -1,
    RPN_AT_CPL_INCOMPLETE_SUBFIELD =  1,
    RPN_AT_CPL_COMPLETE_SUBFIELD   =  2,
    RPN_AT_CPL_COMPLETE_FIELD	   =  3
} RPN_AttribComplete;

char *RPN_AttribComplete_Print(RPN_AttribComplete);


/* RPN_AttribPosition */
typedef enum {
    RPN_AT_POS_UNSPECIFIED    = -1,
    RPN_AT_POS_FIRST_FIELD    =	 1,
    RPN_AT_POS_FIRST_SUBFIELD =	 2,
    RPN_AT_POS_ANYWHERE	      =	 3
} RPN_AttribPosition;

char *RPN_AttribPosition_Print(RPN_AttribPosition);


/* RPN_AttribRelation */
typedef enum {
    RPN_AT_REL_LESS_THAN     = 1,
    RPN_AT_REL_LESS_EQUAL    = 2,
    RPN_AT_REL_EQUAL	     = 3,
    RPN_AT_REL_GREATER_EQUAL = 4,
    RPN_AT_REL_GREATER_THAN  = 5,
    RPN_AT_REL_NOT_EQUAL     = 6
} RPN_AttribRelation;

char *RPN_AttribRelation_Print(RPN_AttribRelation);


/* RPN_AttribStruct */
typedef enum {
    RPN_AT_STR_UNSPECIFIED =  -1,
    RPN_AT_STR_PHRASE	   =   1,
    RPN_AT_STR_WORD	   =   2,
    RPN_AT_STR_KEY	   =   3,
    RPN_AT_STR_YEAR	   =   4,
    RPN_AT_STR_DATE_NORM   =   5,
    RPN_AT_STR_WORD_LIST   =   6,
    RPN_AT_STR_DATE_UNNORM = 100,
    RPN_AT_STR_NAME_NORM   = 101,
    RPN_AT_STR_NAME_UNNORM = 102
} RPN_AttribStruct;

char *RPN_AttribStruct_Print(RPN_AttribStruct);


/* RPN_AttribTrunc */
typedef enum {
    RPN_AT_TRN_UNSPECIFIED =  -1,
    RPN_AT_TRN_RIGHT	   =   1,
    RPN_AT_TRN_LEFT	   =   2,
    RPN_AT_TRN_BOTH	   =   3,
    RPN_AT_TRN_DONT	   = 100,
    RPN_AT_TRN_PROCNUM	   = 101
} RPN_AttribTrunc;

char *RPN_AttribTrunc_Print(RPN_AttribTrunc);


/* RPN_AttribUse */
typedef enum {
    RPN_AT_USE_PERSONAL_NAME	= 1,
    RPN_AT_USE_CORPORATE_NAME	= 2,
    RPN_AT_USE_CONFERENCE_NAME	= 3,
    RPN_AT_USE_TITLE		= 4,
    RPN_AT_USE_SERIES_TITLE	= 5,
    RPN_AT_USE_UNIFORM_TITLE	= 6,
    RPN_AT_USE_ISBN		= 7,
    RPN_AT_USE_ISSN		= 8,
    RPN_AT_USE_LC_CARDNUM 	= 9,
    RPN_AT_USE_BNB_CARDNUM	= 10,
    RPN_AT_USE_BGF_NUM		= 11,
    RPN_AT_USE_LOCAL_NUM	= 12,
    RPN_AT_USE_DEWEY_CLASS	= 13,
    RPN_AT_USE_UDC_CLASS	= 14,
    RPN_AT_USE_BLISS_CLASS	= 15, 
    RPN_AT_USE_LC_CALL_NUM	= 16,
    RPN_AT_USE_NLM_CALL_NUM	= 17, 
    RPN_AT_USE_NAL_CALL_NUM	= 18,
    RPN_AT_USE_MOS_CALL_NUM	= 19,
    RPN_AT_USE_LOCAL_CLASS	= 20,
    RPN_AT_USE_SUBJECT_HEAD	= 21,
    RPN_AT_USE_SUBJECT_RAMEAU	= 22, 
    RPN_AT_USE_BDI_INDEX_SUB	= 23,
    RPN_AT_USE_INSPEC_SUB	= 24,
    RPN_AT_USE_MESH_SUB		= 25,
    RPN_AT_USE_PA_SUB		= 26, 
    RPN_AT_USE_LC_SUB_HEAD	= 27,
    RPN_AT_USE_RVM_SUB_HEAD	= 28,
    RPN_AT_USE_LOCAL_SUB_IDX	= 29,
    RPN_AT_USE_DATE     	= 30,
    RPN_AT_USE_DATE_OF_PUB     	= 31,
    RPN_AT_USE_DATE_OF_AQU     	= 32,
    RPN_AT_USE_TITLE_KEY	= 33,
    RPN_AT_USE_TITLE_COLLECT	= 34,
    RPN_AT_USE_TITLE_PARALLEL	= 35,
    RPN_AT_USE_TITLE_COVER	= 36,
    RPN_AT_USE_TITLE_ADDEDPG	= 37,
    RPN_AT_USE_TITLE_CAPTION	= 38,
    RPN_AT_USE_TITLE_RUNNING	= 39,
    RPN_AT_USE_TITLE_SPINE	= 40,
    RPN_AT_USE_TITLE_OTH_VAR	= 41,
    RPN_AT_USE_TITLE_FORMER	= 42,
    RPN_AT_USE_TITLE_ABBERV	= 43,
    RPN_AT_USE_TITLE_EXPANDED	= 44,
    RPN_AT_USE_SUB_PRECIS	= 45,
    RPN_AT_USE_SUB_RSWK		= 46,
    RPN_AT_USE_SUB_SUBDIVISION	= 47,
    RPN_AT_USE_NUM_NATL_BIB	= 48,
    RPN_AT_USE_NUM_LEGAL_DEP    = 49,
    RPN_AT_USE_NUM_GOVT_PUB	= 50,
    RPN_AT_USE_NUM_PUB_FOR_MUSC	= 51,
    RPN_AT_USE_NUM_DB		= 52,
    RPN_AT_USE_NUM_LOCAL_CALL	= 53,
    RPN_AT_USE_CODE_LANG	= 54,
    RPN_AT_USE_CODE_GEO_AREA	= 55,
    RPN_AT_USE_CODE_INSTIT	= 56,
    RPN_AT_USE_NAME_AND_TITLE	= 57,
    RPN_AT_USE_NAME_GEOGRAPH	= 58,
    RPN_AT_USE_PLACE_PUB	= 59,
    RPN_AT_USE_CODEN		= 60,
    RPN_AT_USE_MICROFROM_GEN	= 61,
    RPN_AT_USE_ABSTRACT		= 62,
    RPN_AT_USE_NOTE		= 63,
    RPN_AT_USE_AUTHOR_TITLE	= 1000,
    RPN_AT_USE_RECORD_TYPE	= 1001,
    RPN_AT_USE_NAME		= 1002,
    RPN_AT_USE_AUTHOR		= 1003,
    RPN_AT_USE_AUTHOR_PERSONAL	= 1004,
    RPN_AT_USE_AUTHOR_CORP	= 1005,
    RPN_AT_USE_AUTHOR_CONF	= 1006,
    RPN_AT_USE_ID_STANDARD	= 1007,
    RPN_AT_USE_SUB_LC_CHILD	= 1008,
    RPN_AT_USE_SUB_NAME_PERS	= 1009,
    RPN_AT_USE_BODY_OF_TEXT	= 1010,
    RPN_AT_USE_DATE_TIME_ADDED	= 1011,
    RPN_AT_USE_DATE_TIME_MOD	= 1012,
    RPN_AT_USE_AUTH_FMT_ID	= 1013,
    RPN_AT_USE_CONCEPT_TEXT	= 1014,
    RPN_AT_USE_CONCEPT_REFER	= 1015,
    RPN_AT_USE_ANY		= 1016,
    RPN_AT_USE_DEFAULT		= 1017
} RPN_AttribUse;

char *RPN_AttribUse_Print(RPN_AttribUse);

typedef enum {
	RPN_LOCAL_DEFINE,
	RPN_PRE_DEFINE,
} RPN_ATTRIB_CLASS;



/* RPN_AttribTerm */
typedef struct {
    RPN_AttribUse	use;
    RPN_AttribRelation	relation;
    RPN_AttribPosition	position;
    RPN_AttribStruct	structure;
    RPN_AttribTrunc	truncation;
    RPN_AttribComplete	completeness;
    char		*value;
    RPN_ATTRIB_CLASS	class;
    char		*className;
    int 		classIndex;
} RPN_AttribTerm;

RPN_AttribTerm *RPN_AttribTerm_New(RPN_AttribUse use, 
    RPN_AttribRelation relation,
    RPN_AttribPosition position, 
    RPN_AttribStruct structure,
    RPN_AttribTrunc truncation, 
    RPN_AttribComplete completeness, 
    char *value,
    RPN_ATTRIB_CLASS  class,
    char *className,
    int  classIndex);

RPN_AttribTerm *RPN_AttribTerm_Copy(RPN_AttribTerm *);
void	       RPN_AttribTerm_Free(RPN_AttribTerm *);
char	       *RPN_AttribTerm_Print(RPN_AttribTerm *);


/* RPN_ResultSetId */
typedef struct {
    char	*set_name;
} RPN_ResultSetId;

RPN_ResultSetId *RPN_ResultSetId_New(const char *result_set_name);
RPN_ResultSetId *RPN_ResultSetId_Copy(RPN_ResultSetId *);
void			RPN_ResultSetId_Free(RPN_ResultSetId *);


/* RPN_Operand */
typedef struct {
    int	    rpn_op_type;
    #define RPN_OPERAND_ATTRIB_TERM 0
    #define RPN_OPERAND_RESULT_SET  1

    union {
		RPN_AttribTerm	*rpn_op_at;
		RPN_ResultSetId *rpn_op_rid;
	} v;
} RPN_Operand;

RPN_Operand *RPN_Operand_NewAT(RPN_AttribTerm *);
RPN_Operand *RPN_Operand_NewRS(RPN_ResultSetId *);
RPN_Operand *RPN_Operand_Copy(RPN_Operand *);
void	    RPN_Operand_Free(RPN_Operand *);
char	    *RPN_Operand_Print(RPN_Operand *);


/* RPN_Operator */
typedef enum {
	RPNOP_AND,
	RPNOP_OR,
	RPNOP_AND_NOT,
	RPNOP_NUM_OPERS
} RPN_Operator;

char *RPN_Operator_Print(RPN_Operator);


/* RPN_Expression */
typedef struct {
    struct _RPN_Structure   *op1;
    struct _RPN_Structure   *op2;
    RPN_Operator		    operator;	/* op1 <operator> op2 */
} RPN_Expression;

RPN_Expression	*RPN_Expression_New(struct _RPN_Structure *op1, RPN_Operator operator, struct _RPN_Structure *op2);
RPN_Expression	*RPN_Expression_Copy(RPN_Expression *);
void		RPN_Expression_Free(RPN_Expression *);
char		*RPN_Expression_Print(RPN_Expression *);
int		RPN_Expression_TreePrint(RPN_Expression *,
		    int (*item_print)(const char *, int, int, long user_data),
		    long user_data,
		    int indent_level);


/* RPN_Structure */
typedef struct _RPN_Structure {
    int	    rpn_struct_type;
    #define RPN_STRUCT_OPERAND	0
    #define RPN_STRUCT_EXPR	1

    union {
		RPN_Operand	*operand;
		RPN_Expression	*expression;
	} v;
} RPN_Structure;

RPN_Structure	 *RPN_Structure_NewOp(RPN_Operand *);
RPN_Structure	 *RPN_Structure_NewEx(RPN_Expression *);
RPN_Structure	 *RPN_Structure_Copy(RPN_Structure *);
void		 RPN_Structure_Free(RPN_Structure *);
char		 *RPN_Structure_Print(RPN_Structure *);
RPN_Structure	 *RPN_Structure_TreeFind(RPN_Structure *str, int print_order, RPN_Structure **parent);
int		 RPN_Structure_TreePrint(RPN_Structure *str,
		     int (*item_print)(const char *item, int indent_level, int is_operand, long user_data),
		     long user_data);
int		 RPN_Structure_Size(RPN_Structure *str);


void RPN_StructToIrRPN(RPN_Structure   *str, IR_RPN_QUERY_STRUCT *query);

void IRRPN_DestroyQuery(IR_RPN_QUERY_STRUCT *query);


#endif
